#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

set <pair < pair <int, int>, int> > ev, calls;
vector <int> peop[200000], nextcall;
vector <int> st, sta;
int ans[200000], calltime[200000], callnumb[200000];

int getindex(int a){
    int l = 0, r = sta.size() - 1;
    while (l < r){
        int m = (l + r + 1) / 2;
        if (sta[m] > a){
            r = m - 1;
        }
        else{
            l = m;
        }
    }
    return l + 1;
}

int main() {
    int n, m, done = 0;
    scanf("%d %d", &n, &m);
    for (int i = 0; i < n; i++){
        int t, a;
        scanf("%d %d", &t, &a);
        ev.insert({{t, i - 1e9}, a});
        st.push_back(a);
        nextcall.push_back(t);
    }
    for (int i = 0; i <= n; i++){
        calltime[i] = -1;
    }
    st.push_back(1);
    sort(st.begin(), st.end());
    for (int i = 0; i < st.size(); i++){
        if (i == 0 || st[i] != st[i - 1]){
            sta.push_back(st[i]);
        }
    }

    ev.insert({{0, 3}, 1});
    int ind = 0, current = 0;
    while (done < n) {
        auto cur = *(ev.begin());
        while (current < nextcall.size() && nextcall[current] <= cur.first.first){
            current++;
        }
        if (cur.first.second == 3) {
            if (!calls.empty()) {
                auto fir = *(calls.begin());
                for (int j = getindex(fir.second); j >= 2; j--) {
                    ev.insert({{cur.first.first + 2 * fir.second - (sta[j - 1]) - 1, 2}, sta[j - 1]});
                }
                ev.insert({{cur.first.first + 2 * (fir.second - 1), 3}, 1});
            } else {
                if (current < nextcall.size()) {
                    ev.insert({{nextcall[current], 3}, 1});
                }
            }
        } else if (cur.first.second < 0) {
            int index = getindex(cur.second);
            if (calltime[index] == -1) {
                calls.insert(cur);
                calltime[index] = cur.first.first;
                callnumb[index] = cur.first.second;
            }
            peop[index].push_back(ind);
        }
        else{
            int index = getindex(cur.second);
            for (int i = 0; i < peop[index].size(); i++){
                ans[peop[index][i]] = cur.first.first + cur.second - 1;
                done++;
            }
            if (peop[index].size() > 0) {
                peop[index].clear();
                calls.erase({{calltime[index], callnumb[index]}, cur.second});
                calltime[index] = -1;
            }
        }
        ev.erase(cur);
        ind++;
    }
    for (int i = 0; i < ind; i++){
        if (ans[i]){
            printf("%d\n", ans[i]);
        }
    }
    return 0;
}