#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

vector <int> t[200010];
int maxlen[200010], retlen[200010], maxim = -1e9;
bool used[200010];

void dfs(int k) {
	vector <int> child;
	maxlen[k] = 1;
	for (int i = 0; i < t[k].size(); i++) {
		if (!used[t[k][i]]) {
			used[t[k][i]] = true;
			dfs(t[k][i]);
			maxlen[k] = max(maxlen[k], maxlen[t[k][i]] + 1);
			child.push_back(-maxlen[t[k][i]]);
		}
	}
	if (child.size() <= 1) {
		retlen[k] = -1e9;
	}
	else {
		sort(child.begin(), child.end());
		retlen[k] = -child[0] - child[1] + 1;
	}
	maxim = max(maxim, retlen[k]);
}

int main() {
	int n; ll m;
	scanf("%d %lld", &n, &m);
	for (int i = 2; i <= n; i++) {
		int p;
		scanf("%d", &p);
		t[p].push_back(i);
	}
	used[1] = true;
	dfs(1);
	ll plus = (m - 1) * maxlen[1];
	printf("%lld", max(maxim + 2 * plus, plus + maxlen[1]));
	return 0;
}
