#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

const int sz = 51;
int dp[2], m, n, res[sz], mn[2];
vector < pair<int, int> > need;

int findseg(int a) {
	int l = 0, r = n - 1;
	while (l < r) {
		int m1 = (l + r + 1) / 2;
		if (need[m1].first <= a) {
			l = m1;
		}
		else {
			r = m1 - 1;
		}
	}
	return l;
}

set <int> cnt(int ll, int rr, int p) {
	int segl = findseg(ll), segr = findseg(rr);
	if (segl == segr) {
		dp[p] = 0;
		set <int> newp;
		newp.insert(need[segl].second);
		return newp;
	}

	int mm = (ll + rr) / 2;
	auto poi1 = cnt(ll, mm, 0);
	int d[2];
	d[0] = dp[0];
	auto poi2 = cnt(mm + 1, rr, 1);
	dp[0] = d[0];

	set <int> un, dif;
	for (auto it = poi1.begin(); it != poi1.end(); it++) {
		if (poi2.find(*(it)) != poi2.end()) {
			dif.insert(*(it));
		}
		un.insert(*(it));
	}
	for (auto it = poi2.begin(); it != poi2.end(); it++) {
		un.insert(*(it));
	}
	dp[p] = dp[0] + dp[1];
	if (dif.size() > 0) {
		return dif;
	}
	else {
		dp[p]++;
		return un;
	}
}

int main() {
	int k;
	scanf("%d %d %d", &k, &n, &m);
	int leng = 1;
	for (int i = 0; i < k; i++) {
		leng *= 2;
	}
	int cur = 0;
	for (int i = 0; i < n; i++) {
		int c, v;
		scanf("%d %d", &c, &v);
		need.push_back({ cur, v });
		cur += c;
	}
	cnt(0, leng - 1, 0);
	printf("%d", dp[0] + 1);
	return 0;
}