#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
typedef long long ll;

int dp[3000000][11], m;
vector <int> need;

int cnt(int cur, int ll, int rr, int color) {
	if (ll == rr) {
		if (color == need[ll]) {
			return 0;
		}
		return 1;
	}
	int mm = (ll + rr) / 2;
	vector <int> lef, rig;
	lef.push_back(0); rig.push_back(0);
	for (int i = 1; i <= m; i++) {
		lef.push_back(cnt(2 * cur + 1, ll, mm, i));
		rig.push_back(cnt(2 * cur + 1, mm + 1, rr, i));
	}
	int result = lef[color] + rig[color];
	for (int j = 1; j <= m; j++) {
		result = min(result, lef[color] + rig[j] + 1);
		result = min(result, rig[color] + lef[j] + 1);
	}
	return result;
}

int main() {
	int k, n;
	scanf("%d %d %d", &k, &n, &m);
	int leng = 1;
	for (int i = 0; i < k; i++) {
		leng *= 2;
	}
	int cur = 0;
	for (int i = 0; i < n; i++) {
		int c, v;
		scanf("%d %d", &c, &v);
		for (int i = cur; i < cur + c; i++) {
			need.push_back(v);
		}
		cur += c;
	}
	int ans = 1e9;
	for (int i = 1; i <= m; i++) {
		ans = min(ans, cnt(0, 0, leng - 1, i) + 1);
	}
	printf("%d", ans);
	return 0;
}