#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

set <pair< pair <int, int>, int> > ev;
set <pair<int, int> > calls;
vector <int> peop[200000];
int ans[200000], calltime[200000];

int main() {
    int n, m, done = 0;
    scanf("%d %d", &n, &m);
    for (int i = 0; i < n; i++){
        int t, a;
        scanf("%d %d", &t, &a);
        ev.insert({{t, i - 1e9}, a});
    }
    for (int i = 1; i <= m; i++){
        calltime[i] = -1;
    }
    ev.insert({{0, 3}, 1});
    int ind = 0;
    while (done < n) {
        auto cur = *(ev.begin());
        if (cur.first.second == 3) {
            if (!calls.empty()) {
                auto fir = *(calls.begin());
                for (int j = fir.second; j >= 2; j--) {
                    ev.insert({{cur.first.first + 2 * fir.second - j - 1, 2}, j});
                }
                ev.insert({{cur.first.first + 2 * (fir.second - 1), 3}, 1});
            } else {
                ev.insert({{cur.first.first + 1, 3}, 1});
            }
        } else if (cur.first.second < 0) {
            if (calltime[cur.second] == -1) {
                calls.insert({cur.first.first, cur.second});
                calltime[cur.second] = cur.first.first;
            }
            peop[cur.second].push_back(ind);
        }
        else{
            for (int i = 0; i < peop[cur.second].size(); i++){
                ans[peop[cur.second][i]] = cur.first.first + cur.second - 1;
                done++;
            }
            if (peop[cur.second].size() > 0) {
                peop[cur.second].clear();
                calls.erase({calltime[cur.second], cur.second});
                calltime[cur.second] = -1;
            }
        }
        ev.erase(cur);
        ind++;
    }
    for (int i = 0; i < ind; i++){
        if (ans[i]){
            printf("%d\n", ans[i]);
        }
    }
    return 0;
}