#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
typedef long long ll;

queue <vector <int> > q;
queue <int> ra;

bool used[50000000];
vector <int> need;
int m;

int gethash(vector <int> v) {
	int res = 0;
	for (int i = 0; i < v.size(); i++) {
		res *= m;
		res += (v[i] - 1);
	}
	return res;
}

int main() {
	int k, n;
	scanf("%d %d %d", &k, &n, &m);
	int leng = 1;
	for (int i = 0; i < k; i++) {
		leng *= 2;
	}
	int cur = 0;
	for (int i = 0; i < n; i++) {
		int c, v;
		scanf("%d %d", &c, &v);
		for (int i = cur; i < cur + c; i++) {
			need.push_back(v);
		}
		cur += c;
	}
	for (int i = 1; i <= m; i++) {
		vector <int> a;
		a.clear();
		for (int j = 0; j < leng; j++) {
			a.push_back(i);
		}
		used[gethash(a)] = true;
		q.push(a);
		ra.push(1);
	}
	while (!q.empty()) {
		vector <int> a1 = q.front(), a;
		a.resize(leng);
		int r = ra.front();
		ra.pop();
		q.pop();
		bool ok = true;
		for (int i = 0; i < leng; i++) {
			if (a1[i] != need[i]) {
				ok = false;
				break;
			}
		}
		if (ok) {
			printf("%d", r);
			return 0;
		}
		for (int v = 1; v <= m; v++) {
			for (int i = 0; i < leng; i++) {
				int max2 = 1;
				while (i % max2 == 0 && max2 <= leng) {
					for (int j = 0; j < leng; j++) {
						a[j] = a1[j];
					}
					for (int j = 0; j < max2; j++) {
						a[i + j] = v;
					}
					int hsh = gethash(a);
					if (!used[hsh]) {
						used[hsh] = true;
						q.push(a);
						ra.push(r + 1);
					}
					max2 *= 2;
				}
			}
		}
	}
	return 0;
}
