#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
typedef long long ll;

const int sz = 51;
int dp[2][sz], m, n, res[sz], mn[2];
vector < pair<int, int> > need;

int findseg(int a) {
	int l = 0, r = n - 1;
	while (l < r) {
		int m1 = (l + r + 1) / 2;
		if (need[m1].first <= a) {
			l = m1;
		}
		else {
			r = m1 - 1;
		}
	}
	return l;
}

void cnt(int ll, int rr, int p) {
	int segl = findseg(ll), segr = findseg(rr);
	if (segl == segr) {
		for (int i = 1; i <= m; i++) {
			dp[p][i] = 1;
		}
		dp[p][need[segl].second] = 0;
		return;
	}


	int mm = (ll + rr) / 2;	
	cnt(ll, mm, 0);
	int d[2][sz], minn[2];
	for (int s = 1; s <= m; s++) {
		d[0][s] = dp[0][s];
	}
	minn[0] = mn[0];
	cnt(mm + 1, rr, 1);
	for (int s = 1; s <= m; s++) {
		dp[0][s] = d[0][s];
	}
	mn[0] = minn[0];

	for (int i = 1; i <= m; i++) {
		res[i] = dp[0][i] + dp[1][i];
		res[i] = min(res[i], dp[0][i] + mn[1] + 1);
		res[i] = min(res[i], mn[0] + dp[1][i] + 1);
	}
	mn[p] = 1e9;
	for (int i = 1; i <= m; i++) {
		dp[p][i] = res[i];
		mn[p] = min(mn[p], res[i]);
	}
}

int main() {
	int k;
	scanf("%d %d %d", &k, &n, &m);
	int leng = 1;
	for (int i = 0; i < k; i++) {
		leng *= 2;
	}
	int cur = 0;
	for (int i = 0; i < n; i++) {
		int c, v;
		scanf("%d %d", &c, &v);
		//c = 1, v = (i + 1) % 10 + 1;
		need.push_back({ cur, v });
		cur += c;
	}
	cnt(0, leng - 1, 0);
	int ans = 1e9;
	for (int i = 1; i <= m; i++) {
		ans = min(ans, dp[0][i] + 1);
	}
	printf("%d", ans);
	return 0;
}