#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
typedef long long ll;

int dp[3000000][11], m;
vector <int> need;

void cnt(int cur, int ll, int rr) {
	if (ll == rr) {
		for (int i = 1; i <= m; i++) {
			dp[cur][i] = 1;
		}
		dp[cur][need[ll]] = 0;
		return;
	}
	int mm = (ll + rr) / 2;
	cnt(2 * cur + 1, ll, mm);
	cnt(2 * cur + 2, mm + 1, rr);
	for (int i = 1; i <= m; i++) {
		dp[cur][i] = dp[2 * cur + 1][i] + dp[2 * cur + 2][i];
		for (int j = 1; j <= m; j++) {
			dp[cur][i] = min(dp[cur][i], dp[2 * cur + 1][i] + dp[2 * cur + 2][j] + 1);
			dp[cur][i] = min(dp[cur][i], dp[2 * cur + 1][j] + dp[2 * cur + 2][i] + 1);
		}
	}
}

int main() {
	int k, n;
	scanf("%d %d %d", &k, &n, &m);
	int leng = 1;
	for (int i = 0; i < k; i++) {
		leng *= 2;
	}
	int cur = 0;
	for (int i = 0; i < n; i++) {
		int c, v;
		scanf("%d %d", &c, &v);
		for (int i = cur; i < cur + c; i++) {
			need.push_back(v);
		}
		cur += c;
	}
	cnt(0, 0, leng - 1);
	int ans = 1e9;
	for (int i = 1; i <= m; i++) {
		ans = min(ans, dp[0][i] + 1);
	}
	printf("%d", ans);
	return 0;
}